//------------------------------------------------------------------------------------------------------------------------------
// 256b Dither Plasma
// Code: Cruzer/CML
// Asm: KickAss 3.16
//------------------------------------------------------------------------------------------------------------------------------
.import source "cruzersLib.asm"
//------------------------------------------------------------------------------------------------------------------------------
.var plasmaCnt =	$02
.var plasmaYpnt =	$06
.var yPos =		$0f
.var xPnts0 =		$10
.var xPnts1 =		$50
.var xPos =		$a8
.var charBuffer =	$f5

.var code =		$0801
.var screen =		$0c00
.var sine128 =		$1000
.var charset =		$2000

.pc = code "code"
//------------------------------------------------------------------------------------------------------------------------------
.var RANDOM = -1

.var effect = 3 //set to RANDOM for random parameters

.var speed0
.var speed1
.var speed2
.var xSpread0
.var xSpread1
.var ySpread0
.var ySpread1
.var ySpread2

.if (effect == RANDOM) {
	.eval speed0 =		rndNot0(-4, 4)
	.eval speed1 =		rndNot0(-4, 4)
	.eval speed2 =		rndNot0(-6, 6)
	.eval xSpread0 =	rndNot0(-7, 7)
	.eval xSpread1 =	rndNot0(-7, 7)
	.eval ySpread0 =	rndNot0(-8, 8)
	.eval ySpread1 =	rndNot0(-8, 8)
	.eval ySpread2 =	rndNot0(-12, 12)
}
.if (effect == 1) {
	.eval speed0 =     -2
	.eval speed1 =     -3
	.eval speed2 =     1
	.eval xSpread0 =   -2
	.eval xSpread1 =   2
	.eval ySpread0 =   -3
	.eval ySpread1 =   -5
	.eval ySpread2 =   8
}

.if (effect == 2) {
	.eval speed0 =      -2
	.eval speed1 =      3
	.eval speed2 =      -1
	.eval xSpread0 =    5
	.eval xSpread1 =    5
	.eval ySpread0 =    2
	.eval ySpread1 =    -5
	.eval ySpread2 =    -7
}

.if (effect == 3) {
	.eval speed0 =      3
	.eval speed1 =      2
	.eval speed2 =      4
	.eval xSpread0 =    -4
	.eval xSpread1 =    3
	.eval ySpread0 =    5
	.eval ySpread1 =    4
	.eval ySpread2 =    -7
}

.if (effect == 4) {
	.eval speed0 =      -2
	.eval speed1 =      3
	.eval speed2 =      -1
	.eval xSpread0 =    -1
	.eval xSpread1 =    -4
	.eval ySpread0 =    -4
	.eval ySpread1 =    3
	.eval ySpread2 =    7
}

// print params so they can be copy/pasted into the code if some random ones turn out to be totally awesome...
.print ""
.print ".eval speed0 =      " + toIntString(speed0)
.print ".eval speed1 =      " + toIntString(speed1)
.print ".eval speed2 =      " + toIntString(speed2)
.print ".eval xSpread0 =    " + toIntString(xSpread0)
.print ".eval xSpread1 =    " + toIntString(xSpread1)
.print ".eval ySpread0 =    " + toIntString(ySpread0)
.print ".eval ySpread1 =    " + toIntString(ySpread1)
.print ".eval ySpread2 =    " + toIntString(ySpread2)
.print ""
//------------------------------------------------------------------------------------------------------------------------------
// Basic
.by $2f,$08,$00,$00,$81,$49,$b2,$30,$a4,$35,$31,$32,$3a,$97,$38,$ae,$34,$aa,$49,$2c,$36,$34,$aa,$36,$34,$ac
.by $bf,$28,$49,$ad,$34,$30,$2e,$37,$34,$29,$3a,$82,$3a,$9e,$32,$30,$39,$36,$00,$00,$00
//------------------------------------------------------------------------------------------------------------------------------
// init chars...

loop:	
	ldx #7
!:
mcb:	lda charBuffer,x
	sta charset + $000
	lsr
	eor #$ff
sc2:	sta charset + $1ff
	inc mcb+3
	beq done
	dec sc2+1
	dex
	bpl !-
	
	ldx #$07
	ldy yPos
	lda xPos
	sec
	sbc #3
	bpl !+
	iny
	iny
	iny
!:	and #$03
	sax xPos
	tya
	sax yPos

	ldx xPos
	lda pixels,x
	ldx yPos
	ora charBuffer,x
	sta charBuffer,x
	
	bne loop
done:

	ldx #0
!:	lda charset+$000,x
	eor #$ff
	sta charset+$200,x
	lda charset+$100,x
	eor #$ff
	sta charset+$300,x
	inx
	bne !-
//------------------------------------------------------------------------------------------------------------------------------
mainLoop:
	:mb #>screen; !ss+ +2
	
	ldx #2
!:	lda plasmaCnt,x
	clc
	adc speeds,x
	sta plasmaCnt,x
	sta plasmaYpnt,x
	stx !ss+ +1
	dex
	bpl !-

	lda plasmaCnt+0
	ldy plasmaCnt+1
	ldx #$38
	stx $d018
!initLoop:
	clc
	adc #xSpread0
	sta xPnts0,x
	tya
	clc
	adc #xSpread1
	sta xPnts1,x
	tay
	lda xPnts0,x
	dex
	bpl !initLoop-

!yLoop:
	ldx #2
!:	lda plasmaYpnt,x
	pha
	clc
	adc ySpreads,x
	sta plasmaYpnt,x
	dex
	bpl !-
			
	pla
	sta ls+1
	pla
	sta as+1
	pla
	anc #$7f
	sta add+1
			
	ldx #$27
!xLoop:	
	ldy xPnts0,x
ls:	lda sine128,y
	ldy xPnts1,x
as:	adc sine128,y
add:	adc #0
	anc #$7f
!ss:	sta screen,x
	dex
	bpl !xLoop-
	
	lda !ss- +1
	adc #40
	sta !ss- +1
	bcc !+
	inc !ss- +2
!:
	cmp #<[screen+40*25]
	bne !yLoop-
	
	beq mainLoop

speeds:	.byte speed0, speed1, speed2
ySpreads:	.byte ySpread0, ySpread1, ySpread2

pixels:	
	.by %10000000
	.by %00100000
	.by %00001000
	.by %00000010

